diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/config.h.in metacity-2.27.1/config.h.in
--- ../metacity-2.27.1/config.h.in	2009-09-14 09:05:19.285881365 +0200
+++ metacity-2.27.1/config.h.in	2009-09-14 09:05:34.514577863 +0200
@@ -81,12 +81,18 @@
 /* Define to 1 if you have the <sys/stat.h> header file. */
 #undef HAVE_SYS_STAT_H
 
+/* Define to 1 if you have the <sys/tsol/label_macro.h> header file. */
+#undef HAVE_SYS_TSOL_LABEL_MACRO_H
+
 /* Define to 1 if you have the <sys/types.h> header file. */
 #undef HAVE_SYS_TYPES_H
 
 /* Define to 1 if you have the <unistd.h> header file. */
 #undef HAVE_UNISTD_H
 
+/* Define to 1 if you have the <X11/extensions/Xtsol.h> header file. */
+#undef HAVE_X11_EXTENSIONS_XTSOL_H
+
 /* Define to 1 if you have the <X11/SM/SMlib.h> header file. */
 #undef HAVE_X11_SM_SMLIB_H
 
@@ -109,6 +115,9 @@
    */
 #undef LT_OBJDIR
 
+/* Building with XTSOL support */
+#undef HAVE_XTSOL
+
 /* Name of package */
 #undef PACKAGE
 
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/configure.in metacity-2.27.1/configure.in
--- ../metacity-2.27.1/configure.in	2009-09-14 09:05:19.285951596 +0200
+++ metacity-2.27.1/configure.in	2009-09-14 09:05:34.515020873 +0200
@@ -358,6 +358,20 @@ fi
 
 CPPFLAGS="$metacity_save_cppflags"
 
+### tsol ans Xtsol libraries
+
+found_xtsol=no
+case "$host" in
+    *-*-solaris*)
+        AC_CHECK_HEADERS(X11/extensions/Xtsol.h sys/tsol/label_macro.h,
+			 AC_DEFINE(HAVE_XTSOL, ,[Building with XTSOL support]) found_xtsol=yes,)
+        ;;
+    *)
+        ;;
+esac
+
+AM_CONDITIONAL(XTSOL_DEFINED, test x$found_xtsol = xyes)
+
 SHAPE_LIBS=
 found_shape=no
 AC_CHECK_LIB(Xext, XShapeQueryExtension,
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/Makefile.am metacity-2.27.1/src/Makefile.am
--- ../metacity-2.27.1/src/Makefile.am	2009-09-14 09:05:19.280592011 +0200
+++ metacity-2.27.1/src/Makefile.am	2009-09-14 09:05:34.515423979 +0200
@@ -2,7 +2,7 @@ lib_LTLIBRARIES = libmetacity-private.la
 
 SUBDIRS=wm-tester tools themes
 
-INCLUDES=-I$(srcdir)/include -DMETACITY_LIBEXECDIR=\"$(libexecdir)\" -DHOST_ALIAS=\"@HOST_ALIAS@\" -DMETACITY_LOCALEDIR=\"$(prefix)/@DATADIRNAME@/locale\" -DMETACITY_PKGDATADIR=\"$(pkgdatadir)\" -DMETACITY_DATADIR=\"$(datadir)\" -DG_LOG_DOMAIN=\"metacity\" -DSN_API_NOT_YET_FROZEN=1 @METACITY_CFLAGS@
+INCLUDES=-I$(srcdir)/include -DMETACITY_LIBEXECDIR=\"$(libexecdir)\" -DHOST_ALIAS=\"@HOST_ALIAS@\" -DMETACITY_LOCALEDIR=\"$(prefix)/@DATADIRNAME@/locale\" -DMETACITY_PKGDATADIR=\"$(pkgdatadir)\" -DMETACITY_DATADIR=\"$(datadir)\" -DG_LOG_DOMAIN=\"metacity\" -DSN_API_NOT_YET_FROZEN=1 @METACITY_CFLAGS@ -DBUILD_TX_CODE
 
 metacity_SOURCES= 				\
 	core/async-getprop.c			\
@@ -96,12 +96,15 @@ metacity_SOURCES= 				\
 	ui/theme.h				\
 	ui/themewidget.c			\
 	ui/themewidget.h			\
+ 	core/trusted.c				\
+ 	core/trusted.h				\
+ 	core/trusted-pics.h			\
 	ui/ui.c					\
 	include/all-keybindings.h
 
 # by setting libmetacity_private_la_CFLAGS, the files shared with
 # metacity proper will be compiled with different names.
-libmetacity_private_la_CFLAGS =
+libmetacity_private_la_CFLAGS = -UBUILD_TX_CODE
 libmetacity_private_la_SOURCES=			\
 	core/boxes.c				\
 	include/boxes.h				\
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/atomnames.h metacity-2.27.1/src/core/atomnames.h
--- ../metacity-2.27.1/src/core/atomnames.h	2009-09-14 09:05:19.279817709 +0200
+++ metacity-2.27.1/src/core/atomnames.h	2009-09-14 09:05:34.515752412 +0200
@@ -156,6 +156,9 @@ item(_NET_WM_ACTION_ABOVE)
 item(_NET_WM_ACTION_BELOW)
 item(_NET_WM_STATE_STICKY)
 item(_NET_WM_FULLSCREEN_MONITORS)
+item(_NET_DESKTOP_ROLES)
+item(_NET_TRUSTED_ACTIVE_WINDOW)
+item(_NET_DESKTOP_LABELS)	
 
 #if 0
 /* We apparently never use: */
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/display-private.h metacity-2.27.1/src/core/display-private.h
--- ../metacity-2.27.1/src/core/display-private.h	2009-09-14 09:05:19.272567071 +0200
+++ metacity-2.27.1/src/core/display-private.h	2009-09-14 09:05:34.516179548 +0200
@@ -127,6 +127,9 @@ struct _MetaDisplay
   guint error_trap_synced_at_last_pop : 1;
   MetaEventQueue *events;
   GSList *screens;
+  #ifdef HAVE_XTSOL  
+   GSList *labels;
+  #endif
   MetaScreen *active_screen;
   GHashTable *window_ids;
   int error_traps;
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/display.c metacity-2.27.1/src/core/display.c
--- ../metacity-2.27.1/src/core/display.c	2009-09-14 09:05:19.272868861 +0200
+++ metacity-2.27.1/src/core/display.c	2009-09-14 09:05:34.518366641 +0200
@@ -77,6 +77,9 @@
 #include <X11/extensions/Xfixes.h>
 #endif
 #include <string.h>
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
 
 #define GRAB_OP_IS_WINDOW_SWITCH(g)                     \
         (g == META_GRAB_OP_KEYBOARD_TABBING_NORMAL  ||  \
@@ -415,6 +418,10 @@ meta_display_open (void)
   the_display->screens = NULL;
   the_display->active_screen = NULL;
   
+#ifdef HAVE_XTSOL
+  the_display->labels = NULL;
+#endif
+  
 #ifdef HAVE_STARTUP_NOTIFICATION
   the_display->sn_display = sn_display_new (the_display->xdisplay,
                                         sn_error_trap_push,
@@ -1789,7 +1796,10 @@ event_callback (XEvent   *event,
         meta_window_handle_mouse_grab_op_event (window, event);
       break;
     case EnterNotify:
-      if (display->grab_window == window &&
+#ifdef HAVE_XTSOL
+        tsol_trusted_stripe_atom_update (display, window);
+#endif      
+	if (display->grab_window == window &&
           grab_op_is_mouse (display->grab_op))
         {
           meta_window_handle_mouse_grab_op_event (window, event);
@@ -1881,6 +1891,9 @@ event_callback (XEvent   *event,
         }
       break;
     case LeaveNotify:
+#ifdef HAVE_XTSOL
+      tsol_trusted_stripe_atom_update (display, window);
+#endif
       if (display->grab_window == window &&
           grab_op_is_mouse (display->grab_op))
         meta_window_handle_mouse_grab_op_event (window, event);
@@ -2171,6 +2184,14 @@ event_callback (XEvent   *event,
             else if (event->xproperty.atom ==
                      display->atom__NET_DESKTOP_NAMES)
               meta_screen_update_workspace_names (screen);
+ #ifdef HAVE_XTSOL	    
+             else if (event->xproperty.atom ==
+                      display->atom__NET_DESKTOP_LABELS)
+               tsol_workspace_labels_gconf_update (screen);
+             else if (event->xproperty.atom ==
+                      display->atom__NET_DESKTOP_ROLES)
+               tsol_workspace_roles_gconf_update (screen);
+ #endif /*HAVE_XTSOL */	  	    
 #if 0
             else if (event->xproperty.atom ==
                      display->atom__NET_RESTACK_WINDOW)
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/frame-private.h metacity-2.27.1/src/core/frame-private.h
--- ../metacity-2.27.1/src/core/frame-private.h	2009-09-14 09:05:19.277749894 +0200
+++ metacity-2.27.1/src/core/frame-private.h	2009-09-14 09:05:34.518695591 +0200
@@ -27,16 +27,15 @@
 #include "frame.h"
 #include "window-private.h"
 
-typedef struct _MetaFrameGeometry MetaFrameGeometry;
+/*typedef struct _MetaFrameGeometry MetaFrameGeometry;
 
 struct _MetaFrameGeometry
 {  
-  /* border sizes (space between frame and child) */
   int left_width;
   int right_width;
   int top_height;
   int bottom_height;
-};
+};*/
 
 struct _MetaFrame
 {
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/frame.c metacity-2.27.1/src/core/frame.c
--- ../metacity-2.27.1/src/core/frame.c	2009-09-14 09:05:19.273375745 +0200
+++ metacity-2.27.1/src/core/frame.c	2009-09-14 09:05:34.519144734 +0200
@@ -28,6 +28,9 @@
 #include "bell.h"
 #include "errors.h"
 #include "keybindings.h"
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
 
 #ifdef HAVE_RENDER
 #include <X11/extensions/Xrender.h>
@@ -157,6 +160,17 @@ meta_window_ensure_frame (MetaWindow *wi
                              window->frame->xwindow,
                              window->title);
 
+#ifdef HAVE_XTSOL  
+  /* associate trusted label with the window only if a frame exist */
+  meta_ui_set_frame_label (window->screen->ui,
+			   window->frame->xwindow,
+			   tsol_meta_window_label_get (window));
+  
+  /* make sure the frame window as the same privileges
+   * "real" window */
+  tsol_set_frame_label (window->display->xdisplay, window->xwindow, window->frame->xwindow);
+#endif  
+
   /* Move keybindings to frame instead of window */
   meta_window_grab_keys (window);
 
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/keybindings.c metacity-2.27.1/src/core/keybindings.c
--- ../metacity-2.27.1/src/core/keybindings.c	2009-09-14 09:05:19.272284155 +0200
+++ metacity-2.27.1/src/core/keybindings.c	2009-09-14 09:05:34.520363796 +0200
@@ -47,6 +47,10 @@
 #include <X11/XKBlib.h>
 #endif
 
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif
+
 static gboolean all_bindings_disabled = FALSE;
 
 typedef void (* MetaKeyHandlerFunc) (MetaDisplay    *display,
@@ -2345,6 +2349,42 @@ meta_spawn_command_line_async_on_screen 
                            error))
     return FALSE;
   
+#ifdef HAVE_XTSOL  
+  if (tsol_is_available ())
+    {
+      GdkDisplay *dpy;
+      Display *xdpy;
+      Window root;
+      Atom atom, utf8_string;
+      gchar* tsol_command =  g_strdup_printf ("%d:%s", 
+					      screen->number,
+					      command_line);
+      
+      dpy = gdk_display_get_default ();
+      xdpy = GDK_DISPLAY_XDISPLAY (dpy);
+      
+      utf8_string = XInternAtom (xdpy, "UTF8_STRING", FALSE);
+      
+      root = DefaultRootWindow (xdpy);
+      
+      atom = XInternAtom (xdpy, "_LABEL_EXEC_COMMAND", FALSE);
+      
+      gdk_error_trap_push ();
+      
+      XChangeProperty (xdpy, root, atom, utf8_string, 8, PropModeReplace,
+		       tsol_command, strlen (tsol_command));
+      
+      XSync (xdpy, False);
+      
+      gdk_error_trap_pop ();
+
+      g_free (tsol_command);
+
+      retval = TRUE;
+    }
+  else
+#endif /* HAVE_XTSOL */	  
+    {
   retval = g_spawn_async (NULL,
                           argv,
                           NULL,
@@ -2354,11 +2394,10 @@ meta_spawn_command_line_async_on_screen 
                           NULL,
                           error);
   g_strfreev (argv);
-
+    }
   return retval;
 }
 
-
 static void
 handle_run_command (MetaDisplay    *display,
                     MetaScreen     *screen,
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/prefs.c metacity-2.27.1/src/core/prefs.c
--- ../metacity-2.27.1/src/core/prefs.c	2009-09-14 09:05:19.277296857 +0200
+++ metacity-2.27.1/src/core/prefs.c	2009-09-14 09:05:34.523152341 +0200
@@ -32,6 +32,9 @@
 #endif
 #include <string.h>
 #include <stdlib.h>
+#ifdef HAVE_XTSOL
+#include "trusted.h"
+#endif /* HAVE_XTSOL */
 
 #define MAX_REASONABLE_WORKSPACES 36
 
@@ -106,6 +114,14 @@ static char *commands[MAX_COMMANDS] = { 
 static char *terminal_command = NULL;
 
 static char *workspace_names[MAX_REASONABLE_WORKSPACES] = { NULL, };
+#ifdef HAVE_XTSOL
+/* these are only used for session managements
+ * workspace_labels are NOT used in metacity as the window label 
+ * is queried directly from the window
+ * ditto for the workspace_roles*/
+static char *workspace_labels[MAX_REASONABLE_WORKSPACES] = { NULL, };
+static char *workspace_roles[MAX_REASONABLE_WORKSPACES] = { NULL, };
+#endif /* HAVE_XTSOL */
 
 #ifdef HAVE_GCONF
 static gboolean handle_preference_update_enum (const gchar *key, GConfValue *value);
@@ -128,6 +144,16 @@ static void change_notify (GConfClient  
                            gpointer        user_data);
 
 static char* gconf_key_for_workspace_name (int i);
+#ifdef HAVE_XTSOL
+static void init_labels_roles_workspaces (void);
+static gboolean
+update_workspace_property (char **property,
+ 			   char *error_property_name,
+ 			   const char  *name,
+ 			   const char  *value);
+static char* gconf_key_for_workspace_label (int i);
+static char* gconf_key_for_workspace_role (int i);
+#endif /*HAVE_XTSOL*/
 
 static void queue_changed (MetaPreference  pref);
 
@@ -837,6 +863,40 @@ handle_preference_update_int (const gcha
 
   if (*cursor->target != new_value)
     {
+#ifdef HAVE_XTSOL
+      if (cursor->pref == META_PREF_NUM_WORKSPACES && tsol_use_trusted_extensions ())
+	{
+	  if (*cursor->target > new_value) /* remove a workspace blank label and role */
+	    {
+	      GError *err = NULL;
+	      char *key = gconf_key_for_workspace_label (new_value);
+	      gconf_client_unset (default_client,
+				  key, &err);
+	      update_workspace_property (workspace_labels,"Workspace Label",
+					 key, NULL);
+
+	      g_free (key);
+	      err = NULL;
+	      key = gconf_key_for_workspace_role (new_value);
+	      gconf_client_unset (default_client,
+				  key, &err);
+	      update_workspace_property (workspace_roles ,"Workspace roles",
+					 key, NULL);
+	      g_free (key);
+	    }
+	  else if (new_value > *cursor->target)	   /* add a workspace add default label, blank role */
+	    {
+	      GError *err = NULL;
+	      char *key = gconf_key_for_workspace_role (new_value-1);
+	      gconf_client_unset (default_client,
+				  key, &err);
+	      update_workspace_property (workspace_roles ,"Workspace roles",
+					 key, NULL);
+	      g_free (key);
+	      meta_prefs_change_workspace_label (new_value, tsol_label_get_min ());
+	    }
+	}
+#endif /* HAVE_XTSOL */  
       *cursor->target = new_value;
       queue_changed (cursor->pref);
     }
@@ -1008,6 +1068,11 @@ meta_prefs_init (void)
   /* returns a reference which we hold forever */
   default_client = gconf_client_get_default ();
 
+#ifdef HAVE_XTSOL
+  /* tsol labels and roles */
+  init_labels_roles_workspaces ();
+#endif /* HAVE_XTSOL */  
+
   for (gconf_dir_cursor=gconf_dirs_we_are_interested_in;
        *gconf_dir_cursor!=NULL;
        gconf_dir_cursor++)
@@ -1063,6 +1128,7 @@ meta_prefs_init (void)
 /* Updates.                                                                 */
 /****************************************************************************/
 
+
 #ifdef HAVE_GCONF
 
 gboolean (*preference_update_handler[]) (const gchar*, GConfValue*) = {
@@ -1169,6 +1235,98 @@ change_notify (GConfClient    *client,
       if (update_workspace_name (key, str))
         queue_changed (META_PREF_WORKSPACE_NAMES);
     }
+ #ifdef HAVE_XTSOL
+   else if (g_str_has_prefix (key, KEY_WORKSPACE_LABEL_PREFIX))
+    {
+      const char *str;
+ 
+      if (!tsol_use_trusted_extensions ())
+        goto out;
+ 
+      if (value && value->type != GCONF_VALUE_STRING)
+        {
+          meta_warning (_("GConf key \"%s\" is set to an invalid type\n"),
+                        key);
+          goto out;
+        }
+ 
+      str = value ? gconf_value_get_string (value) : NULL;
+ 
+      /* Check if the label is in range if not set it to USER_MIN_SL or role MIN label 
+       * NOTE : if USER_MIN_SL is not properly set you can have an infinite loop here */
+ 
+      if (str && !tsol_label_is_in_user_range (str))
+        {
+ 	 char *p; /* code from update_workspace_property */
+ 	 int i;
+ 	 
+ 	 p = strrchr (key, '_');
+ 	 if (p != NULL)
+ 	   {
+ 	     ++p;
+ 	     if (g_ascii_isdigit (*p))
+ 	       {
+ 		 i = atoi (p);
+ 		 i -= 1; /* count from 0 not 1 */
+ 		 
+ 		 if (i >= MAX_REASONABLE_WORKSPACES)
+ 		   {
+ 		     meta_topic (META_DEBUG_PREFS,
+ 				 "%s key %d is too highly numbered, ignoring\n", 
+ 				 "trusted workspace label", i);
+ 		   }
+ 		 else
+ 		   {
+ 		     char *name, *role_key;
+ 		     GError *err = NULL;
+ 		     role_key = gconf_key_for_workspace_role (i);
+ 		     name = gconf_client_get_string (default_client, role_key, &err);
+ 		     cleanup_error (&err);
+ 		     g_free (role_key);
+ 
+ 		     if (name)
+ 		       {
+ 			 char *min_role_label = NULL;
+ 			 if (!tsol_label_is_in_role_range (str, name, min_role_label))
+ 			   {
+ 			     if (min_role_label)
+ 			       meta_prefs_change_workspace_label (i, min_role_label);
+ 			     else
+ 			       meta_prefs_change_workspace_label (i, tsol_label_get_min ());
+ 			   }
+ 			 g_free (name);
+ 		       }
+ 		     else
+ 		       meta_prefs_change_workspace_label (i, tsol_label_get_min ());
+ 
+ 		   }
+ 	       }
+ 	   }
+        }
+ 
+      if (update_workspace_property (workspace_labels,"Workspace Label", key, str))
+        queue_changed (META_PREF_WORKSPACE_LABELS);
+    }
+   else if (g_str_has_prefix (key, KEY_WORKSPACE_ROLE_PREFIX))
+    {
+      const char *str;
+      
+      if (!tsol_use_trusted_extensions ())
+        goto out;
+ 
+      if (value && value->type != GCONF_VALUE_STRING)
+        {
+          meta_warning (_("GConf key \"%s\" is set to an invalid type\n"),
+                        key);
+          goto out;
+        }
+ 
+      str = value ? gconf_value_get_string (value) : NULL;
+ 
+      if (update_workspace_property (workspace_roles ,"Workspace roles", key, str))
+        queue_changed (META_PREF_WORKSPACE_ROLES);
+    }
+ #endif /*HAVE_XTSOL*/
   else
     {
       meta_topic (META_DEBUG_PREFS, "Key %s doesn't mean anything to Metacity\n",
@@ -1750,6 +1908,15 @@ meta_preference_to_string (MetaPreferenc
     case META_PREF_COMPOSITING_MANAGER:
       return "COMPOSITING_MANAGER";
 
+#ifdef HAVE_XTSOL
+    case META_PREF_WORKSPACE_LABELS:
+      return "WORKSPACE_LABELS";
+      break;
+    case META_PREF_WORKSPACE_ROLES:
+      return "WORKSPACE_ROLES";
+      break;
+#endif /*HAVE_XTSOL*/     
+    
     case META_PREF_RESIZE_WITH_RIGHT_BUTTON:
       return "RESIZE_WITH_RIGHT_BUTTON";
 
@@ -1941,6 +2108,53 @@ init_commands (void)
 #endif /* HAVE_GCONF */
 }
 
+#ifdef HAVE_XTSOL
+static void init_labels_roles_workspaces (void)
+{
+  #ifdef HAVE_GCONF
+  int i;
+  GError *err;
+  
+  if (!tsol_use_trusted_extensions ())
+    return;
+
+  i = 0;
+  while (i < MAX_REASONABLE_WORKSPACES)
+    {
+      char *str_val;
+      char *label_key, *role_key;
+
+      label_key = gconf_key_for_workspace_label (i);
+
+      err = NULL;
+      str_val = gconf_client_get_string (default_client, label_key, &err);
+      cleanup_error (&err);
+
+      update_workspace_property (workspace_labels,"Workspace Label",
+				 label_key, str_val);
+
+      g_free (str_val);    
+      g_free (label_key);
+
+      role_key = gconf_key_for_workspace_role (i);
+      
+      err = NULL;
+      str_val = gconf_client_get_string (default_client, role_key, &err);
+      cleanup_error (&err);
+
+      update_workspace_property (workspace_roles ,"Workspace roles",
+				 role_key, str_val);
+
+      g_free (str_val);    
+      g_free (role_key);
+
+      ++i;
+    }
+#endif /* HAVE_GCONF */
+}
+#endif /* HAVE_XTSOL */
+
+
 static void
 init_workspace_names (void)
 {
@@ -2418,6 +2632,72 @@ meta_prefs_get_gconf_key_for_terminal_co
 }
 
 #ifdef HAVE_GCONF
+#ifdef HAVE_XTSOL
+static gboolean
+update_workspace_property (char **property,
+			   char *error_property_name,
+			   const char  *name,
+			   const char  *value)
+{
+  char *p;
+  int i;
+
+  if (!tsol_use_trusted_extensions ())
+    return FALSE;
+  
+  p = strrchr (name, '_');
+  if (p == NULL)
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "%s name %s has no underscore?\n", error_property_name, name);
+      return FALSE;
+    }
+  
+  ++p;
+
+  if (!g_ascii_isdigit (*p))
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "%s name %s doesn't end in number?\n", 
+		  error_property_name, name);
+      return FALSE;
+    }
+  
+  i = atoi (p);
+  i -= 1; /* count from 0 not 1 */
+  
+  if (i >= MAX_REASONABLE_WORKSPACES)
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "%s name %d is too highly numbered, ignoring\n", 
+		  error_property_name, i);
+      return FALSE;
+    }
+
+  if (property[i] && value && strcmp (property[i], value) == 0)
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "%s name %d is unchanged\n", error_property_name, i);
+      return FALSE;
+    }  
+
+  if (value != NULL && *value != '\0')
+    {
+      g_free (property[i]);
+      property[i] = g_strdup (value);
+    }
+  else
+    {
+      g_free (property[i]);
+      property[i] = NULL;
+    }
+  
+  return TRUE;
+}
+
+#endif /* HAVE_XTSOL */
+
+
 static gboolean
 update_workspace_name (const char  *name,
                        const char  *value)
@@ -2495,6 +2775,152 @@ update_workspace_name (const char  *name
   return TRUE;
 }
 #endif /* HAVE_GCONF */
+#ifdef HAVE_XTSOL
+const char* meta_prefs_get_workspace_label    (int         i)
+{
+  g_return_val_if_fail (i >= 0 && i < MAX_REASONABLE_WORKSPACES, NULL);
+
+  if (!tsol_use_trusted_extensions ())
+    return NULL;
+
+  return workspace_labels [i];
+}
+void        
+meta_prefs_change_workspace_label (int         i,
+				   const char *name)
+{
+#ifdef HAVE_GCONF
+  char *key;
+  GError *err;
+  
+  g_return_if_fail (i >= 0 && i < MAX_REASONABLE_WORKSPACES);
+
+  if (!tsol_use_trusted_extensions ())
+    return;
+
+  meta_topic (META_DEBUG_PREFS,
+              "Changing name of workspace_labels %d to %s\n",
+              i, name ? name : "none");
+
+  /* This is a bad hack. We have to treat empty string as
+   * "unset" because the root window property can't contain
+   * null. So it gets empty string instead and we don't want
+   * that to result in setting the empty string as a value that
+   * overrides "unset".
+   */
+  if (name && *name == '\0')
+    name = NULL;
+  
+  if ((name == NULL && workspace_labels [i] == NULL) ||
+      (name && workspace_labels[i] && strcmp (name, workspace_labels[i]) == 0))
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "Workspace label %d already has name %s\n",
+                  i, name ? name : "none");
+      return;
+    }
+  
+  key = gconf_key_for_workspace_label (i);
+
+  err = NULL;
+  if (name != NULL)
+    gconf_client_set_string (default_client,
+                             key, name,
+                             &err);
+  else
+    gconf_client_unset (default_client,
+                        key, &err);
+
+  
+  if (err)
+    {
+      meta_warning (_("Error setting name for workspace label %d to \"%s\": %s\n"),
+                    i, name ? name : "none",
+                    err->message);
+      g_error_free (err);
+    }
+
+  update_workspace_property (workspace_labels,"Workspace Label",
+			     key, name);
+  
+  g_free (key);
+#endif /* HAVE_GCONF */
+}
+
+
+const char* meta_prefs_get_workspace_role    (int         i)
+{
+  g_return_val_if_fail (i >= 0 && i < MAX_REASONABLE_WORKSPACES, NULL);
+
+  if (!tsol_use_trusted_extensions ())
+    return NULL;
+
+  return workspace_roles [i];
+}
+
+void        meta_prefs_change_workspace_role (int         i,
+                                              const char *name)
+{
+#ifdef HAVE_GCONF
+  char *key;
+  GError *err;
+  
+  g_return_if_fail (i >= 0 && i < MAX_REASONABLE_WORKSPACES);
+ 
+  if (!tsol_use_trusted_extensions ())
+    return;
+
+  meta_topic (META_DEBUG_PREFS,
+              "Changing name of workspace_roles %d to %s\n",
+              i, name ? name : "none");
+
+  /* This is a bad hack. We have to treat empty string as
+   * "unset" because the root window property can't contain
+   * null. So it gets empty string instead and we don't want
+   * that to result in setting the empty string as a value that
+   * overrides "unset".
+   */
+  if (name && *name == '\0')
+    name = NULL;
+  
+  if ((name == NULL && workspace_roles [i] == NULL) ||
+      (name && workspace_roles [i] && strcmp (name, workspace_roles [i]) == 0))
+    {
+      meta_topic (META_DEBUG_PREFS,
+                  "Workspace role %d already has name %s\n",
+                  i, name ? name : "none");
+      return;
+    }
+  
+  key = gconf_key_for_workspace_role (i);
+
+  err = NULL;
+  if (name != NULL)
+    gconf_client_set_string (default_client,
+                             key, name,
+                             &err);
+  else
+    gconf_client_unset (default_client,
+                        key, &err);
+
+  
+  if (err)
+    {
+      meta_warning (_("Error setting name for workspace role %d to \"%s\": %s\n"),
+                    i, name ? name : "none",
+                    err->message);
+      g_error_free (err);
+    }
+  
+  g_free (key);
+#endif /* HAVE_GCONF */
+
+
+
+
+}
+
+#endif /* HAVE_XTSOL */
 
 const char*
 meta_prefs_get_workspace_name (int i)
@@ -2570,6 +2996,29 @@ meta_prefs_change_workspace_name (int   
 }
 
 #ifdef HAVE_GCONF
+#ifdef HAVE_XTSOL
+static char*
+gconf_key_for_workspace_label (int i)
+{
+  char *key;
+  
+  key = g_strdup_printf (KEY_WORKSPACE_LABEL_PREFIX"%d", i + 1);
+  
+  return key;
+}
+static char*
+gconf_key_for_workspace_role (int i)
+{
+  char *key;
+  
+  key = g_strdup_printf (KEY_WORKSPACE_ROLE_PREFIX"%d", i + 1);
+  
+  return key;
+}
+#endif /* HAVE_XTSOL */
+
+
+
 static char*
 gconf_key_for_workspace_name (int i)
 {
diff -purN -x '*.orig' -x '*.rej' -x '*~' ../metacity-2.27.1/src/core/screen.c metacity-2.27.1/src/core/screen.c
--- ../metacity-2.27.1/src/core/screen.c	2009-09-14 09:05:19.271783576 +0200
+++ metacity-2.27.1/src/core/screen.c	2009-09-14 09:05:34.524363525 +0200
@@ -38,6 +38,7 @@
 #include "stack.h"
 #include "xprops.h"
 #include "compositor.h"
+#include <gtk/gtk.h>
 
 #ifdef HAVE_SOLARIS_XINERAMA
 #include <X11/extensions/xinerama.h>
@@ -573,6 +574,16 @@ meta_screen_new (MetaDisplay *display,
   update_num_workspaces (screen, timestamp);
   
   set_workspace_names (screen);
+#ifdef HAVE_XTSOL
+  if (tsol_is_available ())
+    {
+      tsol_workspace_labels_atom_set (screen);
+      tsol_workspace_roles_atom_set (screen);
+      /* create a synch atom to indicate we are done setting up the 
+         ws lables/roles */
+      XInternAtom (screen->display->xdisplay, "TX_WS_SETUP_DONE", FALSE);
+    }
+#endif /*HAVE_XTSOL */
 
   screen->all_keys_grabbed = FALSE;
   screen->keys_grabbed = FALSE;
@@ -863,6 +874,16 @@ prefs_changed_callback (MetaPreference p
     {
       set_workspace_names (screen);
     }
+#ifdef HAVE_XTSOL  
+  else if (pref == META_PREF_WORKSPACE_LABELS)
+    {
+      tsol_workspace_labels_atom_set (screen);
+    }
+  else if (pref == META_PREF_WORKSPACE_ROLES)
+    {
+      tsol_workspace_roles_atom_set (screen);
+    }
+#endif /*HAVE_XTSOL */
 }
 
 
@@ -1158,6 +1179,13 @@ update_num_workspaces (MetaScreen *scree
     }
 
   set_number_of_spaces_hint (screen, new_num);
+#ifdef HAVE_XTSOL  
+  if (tsol_is_available ())
+    {
+      tsol_workspace_labels_atom_set (screen);
+      tsol_workspace_roles_atom_set (screen);
+    }
+#endif /* HAVE_XTSOL */  
 
   meta_screen_queue_workarea_recalc (screen);
 }
